import org.junit.Assert;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.Timeout;

import java.util.Arrays;

public class Aufgabe1Test {

    @Rule
    public Timeout globalTimeout = Timeout.millis(1000);

    @Test
    public void testDropLeftMutatingSize0() throws Exception {
        int[] array = new int[]{};
        int[] expected = new int[]{};
        Aufgabe1.dropLeftMutating(array,2);
        assert(Arrays.equals(array, expected));
    }

    @Test
    public void testDropLeftMutatingSize1a() throws Exception {
        int[] array = new int[]{1};
        int[] expected = new int[]{2};
        Aufgabe1.dropLeftMutating(array,2);
        Assert.assertArrayEquals(expected, array);
    }

    @Test
    public void testDropLeftMutatingSize1b() throws Exception {
        int[] array = new int[]{1};
        int[] expected = new int[]{1};
        Aufgabe1.dropLeftMutating(array,0);
        Assert.assertArrayEquals(expected, array);
    }

    @Test
    public void testDropLeftMutatingSize6() throws Exception {
        int[] array = new int[]{1,2,3,4,5,6};
        int[] expected = new int[]{2,3,4,4,5,6};
        Aufgabe1.dropLeftMutating(array,4);
        Assert.assertArrayEquals(expected, array);
    }

    @Test
    public void testDropLeftMutatingSize7() throws Exception {
        int[] array = new int[]{2,1,3,4,5,6,7};
        int[] expected = new int[]{1,3,4,5,5,6,7};
        Aufgabe1.dropLeftMutating(array,5);
        Assert.assertArrayEquals(expected, array);
    }

    @Test
    public void testResultDropLeftSize0() throws Exception {
        int[] array = new int[]{};
        int[] expected = new int[]{};
        int[] result = Aufgabe1.dropLeft(array,4);
        Assert.assertArrayEquals(expected, result);
    }

    @Test
    public void testResultDropLeftSize1() throws Exception {
        int[] array = new int[]{6};
        int[] expected = new int[]{6};
        int[] result = Aufgabe1.dropLeft(array,4);
        Assert.assertArrayEquals(expected, result);
    }

    @Test
    public void testResultDropLeftSize6() throws Exception {
        int[] array = new int[]{1,2,3,4,5,6};
        int[] expected = new int[]{2,3,4,4,5,6};
        int[] result = Aufgabe1.dropLeft(array,4);
        Assert.assertArrayEquals(expected, result);
    }

    @Test
    public void testResultDropLeftSize7() throws Exception {
        int[] array = new int[]{2,1,3,4,5,6,7};
        int[] expected = new int[]{1,3,4,5,5,6,7};
        int[] result = Aufgabe1.dropLeft(array,5);
        Assert.assertArrayEquals(expected, result);
        Assert.assertTrue(result != array);
    }

    @Test
    public void testEffectDropLeftSize7() throws Exception {
        int[] array = new int[]{1,2,3,4,5,6,7};
        int[] expected = new int[]{1,2,3,4,5,6,7};
        Aufgabe1.dropLeft(array,4);
        Assert.assertArrayEquals(expected, array);
    }

    @Test
    public void testDropLeftNull() throws Exception {
        int[] result = Aufgabe1.dropLeft(null,4);
        Assert.assertTrue(result==null);
    }

}