import org.junit.Assert;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.Timeout;

public class Aufgabe2Test {

    @Rule
    public Timeout globalTimeout = Timeout.millis(1000);

    @Test
    public void testGet() throws Exception {
        int[][] input = new int[][]{{1,2},
                {3,4,5},
                {6,7,8,9},
                {10,11,12}};
        int[] expectedResult = new int[]{6,7,8,9,3,4,5};
        int[] rows = new int[] {1,3};
        int[] result = Aufgabe2.get(input, new int[]{2,1});
        Assert.assertArrayEquals(expectedResult, result);
    }

    @Test
    public void testGetInvalidIndexPos() throws Exception {
        int[][] input = new int[][]{{1,2},
                {3,4,5},
                {6,7,8,9},
                {10,11,12}};
        int[] expectedResult = new int[]{6,7,8,9,3,4,5};
        int[] rows = new int[] {1,3};
        int[] result = Aufgabe2.get(input, new int[]{2,1,5});
        Assert.assertArrayEquals(expectedResult, result);
    }

    @Test
    public void testGetInvalidIndexNeg() throws Exception {
        int[][] input = new int[][]{{1,2},
                {3,4,5},
                {6,7,8,9},
                {10,11,12}};
        int[] expectedResult = new int[]{6,7,8,9,3,4,5};
        int[] rows = new int[] {1,3};
        int[] result = Aufgabe2.get(input, new int[]{2,-5,1});
        Assert.assertArrayEquals(expectedResult, result);
    }

    @Test
    public void testReshape() throws Exception {
        int[] input = new int[]{1,2,6,7,8,9,11};
        int[][] expectedResult = new int[][]{{1,2,6},{7,8,9},{11}};
        int[][] result = Aufgabe2.reshape(input, 3);
        Assert.assertArrayEquals(expectedResult, result);
    }

}